<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Heiwa documentation &mdash; Heiwa  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Performance" href="performance.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="#" class="icon icon-home"> Heiwa
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="performance.html">Performance</a></li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.html">API Documentation</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="#">Heiwa</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="#" class="icon icon-home"></a> &raquo;</li>
      <li>Heiwa documentation</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/index.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="heiwa-documentation">
<h1>Heiwa documentation<a class="headerlink" href="#heiwa-documentation" title="Permalink to this headline"></a></h1>
<div class="toctree-wrapper compound">
<p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="performance.html">Performance</a><ul>
<li class="toctree-l2"><a class="reference internal" href="performance.html#forum-apis">Forum APIs</a><ul>
<li class="toctree-l3"><a class="reference internal" href="performance.html#listing-with-permissions-parsed">Listing with permissions parsed</a></li>
<li class="toctree-l3"><a class="reference internal" href="performance.html#listing-with-permissions-not-yet-parsed">Listing with permissions not yet parsed</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="performance.html#thread-apis">Thread APIs</a><ul>
<li class="toctree-l3"><a class="reference internal" href="performance.html#listing-in-a-single-forum-with-permissions-parsed">Listing in a single forum with permissions parsed</a></li>
<li class="toctree-l3"><a class="reference internal" href="performance.html#listing-in-multiple-forums-with-permissions-parsed">Listing in multiple forums with permissions parsed</a></li>
<li class="toctree-l3"><a class="reference internal" href="performance.html#listing-in-multiple-forums-with-permissions-not-parsed">Listing in multiple forums with permissions not parsed</a></li>
<li class="toctree-l3"><a class="reference internal" href="performance.html#creating">Creating</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="performance.html#post-apis">Post APIs</a><ul>
<li class="toctree-l3"><a class="reference internal" href="performance.html#id1">Listing in a single forum with permissions parsed</a></li>
<li class="toctree-l3"><a class="reference internal" href="performance.html#id2">Listing in multiple forums with permissions parsed</a></li>
<li class="toctree-l3"><a class="reference internal" href="performance.html#id3">Listing in multiple forums with permissions not parsed</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.html">API Documentation</a><ul>
<li class="toctree-l2"><a class="reference internal" href="heiwa.html#subpackages">Subpackages</a><ul>
<li class="toctree-l3"><a class="reference internal" href="heiwa.authentication.html">Authentication</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.constants.html">Statuses</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.database.html">Database</a><ul>
<li class="toctree-l4"><a class="reference internal" href="heiwa.database.html#subpackages">Subpackages</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.database.html#module-heiwa.database">Contents</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.json_ld.html">JSON-LD</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.enums.html">Enums</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.error_handlers.html">Error handlers</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.exceptions.html">Exceptions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.limiter.html">Rate limiter</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.tasks.html">Tasks</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.types.html">Abstract types</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.validators.html">Validators</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.html">API views</a><ul>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.category.html">Categories</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.file.html">Files</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.forum.html">Forums</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.group.html">Groups</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.guest.html">Guests</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.message.html">Messages</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.meta.html">Meta information</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.notification.html">Notifications</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.oidc.html">OIDC</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.post.html">Posts</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.statistic.html">Statistics</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.thread.html">Threads</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.user.html">Users</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.utils.html">Utilities</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.html#module-heiwa">Root</a></li>
</ul>
</li>
</ul>
</div>
</section>
<section id="indices-and-tables">
<h1>Indices and tables<a class="headerlink" href="#indices-and-tables" title="Permalink to this headline"></a></h1>
<ul class="simple">
<li><p><a class="reference internal" href="genindex.html"><span class="std std-ref">Index</span></a></p></li>
<li><p><a class="reference internal" href="search.html"><span class="std std-ref">Search Page</span></a></p></li>
</ul>
</section>
<section id="notes">
<h1>Notes<a class="headerlink" href="#notes" title="Permalink to this headline"></a></h1>
<section id="http-query-search-method-in-searching-apis">
<h2>HTTP QUERY (SEARCH) method in searching APIs<a class="headerlink" href="#http-query-search-method-in-searching-apis" title="Permalink to this headline"></a></h2>
<p><code class="docutils literal notranslate"><span class="pre">list_</span></code> APIs use the <code class="docutils literal notranslate"><span class="pre">QUERY</span></code> HTTP method, one yet to be standardized. This
was a hard choice to make, but with (nearly) infinitely scalable <code class="docutils literal notranslate"><span class="pre">filter</span></code>
usage, I believe it to be the best option – or more precisely, the one I like
and will use, even if it means forsaking HTTP until it is a part of its
standard.</p>
<p><strong>Why?</strong></p>
<p>Semantically, <code class="docutils literal notranslate"><span class="pre">GET</span></code> requests’ bodies, while allowed, should have no meaning.
URLs should be the only identifier for caching them, nothing else should
matter.</p>
<p>This leaves us with 2 <code class="docutils literal notranslate"><span class="pre">GET</span></code> options;</p>
<ul class="simple">
<li><p>Ignoring semantics and using bodies anyway - the implementation of choice for
a long time. I don’t like this. Semantics are important.</p></li>
<li><p>Putting <em>everything</em> in the URL. I don’t like this one either. It’s going to
make the creation of manual requests significantly harder and require an
overhaul of the current input validation system - which, while messily
generated, works fairly well at its core. And to top it off, there are limits
to URL lengths which could make those large <code class="docutils literal notranslate"><span class="pre">filter</span></code>s completely
impossible.</p></li>
</ul>
<p><code class="docutils literal notranslate"><span class="pre">POST</span></code> requests are also a common choice for developers facing this issue.
They remove the issue of incorrect body semantics, but introduce a new issue -
the lack of semantic idempotence. Using them instead would be trading an old
problem for a different one, especially with caching.</p>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="performance.html" class="btn btn-neutral float-right" title="Performance" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p></p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>